"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.AppNav = void 0;
var _react = require("react");
var _emotion = require("@instructure/emotion");
var _callRenderProp = require("@instructure/ui-react-utils/lib/callRenderProp.js");
var _omitProps = require("@instructure/ui-react-utils/lib/omitProps.js");
var _testable = require("@instructure/ui-testable/lib/testable.js");
var _View = require("@instructure/ui-view/lib/View");
var _Menu = require("@instructure/ui-menu/lib/Menu");
var _Item = require("./Item");
var _styles = _interopRequireDefault(require("./styles"));
var _theme = _interopRequireDefault(require("./theme"));
var _props = require("./props");
var _TruncateList = require("@instructure/ui-truncate-list/lib/TruncateList");
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _dec, _dec2, _class, _AppNav;
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
/**
---
category: components
---
**/
let AppNav = exports.AppNav = (_dec = (0, _emotion.withStyle)(_styles.default, _theme.default), _dec2 = (0, _testable.testable)(), _dec(_class = _dec2(_class = (_AppNav = class AppNav extends _react.Component {
  constructor(...args) {
    super(...args);
    this.state = {
      isMeasuring: false
    };
    this.ref = null;
    this.handleRef = el => {
      const elementRef = this.props.elementRef;
      this.ref = el;
      if (typeof elementRef === 'function') {
        elementRef(el);
      }
    };
  }
  componentDidMount() {
    var _this$props$makeStyle, _this$props;
    (_this$props$makeStyle = (_this$props = this.props).makeStyles) === null || _this$props$makeStyle === void 0 ? void 0 : _this$props$makeStyle.call(_this$props);
  }
  componentDidUpdate() {
    var _this$props$makeStyle2, _this$props2;
    (_this$props$makeStyle2 = (_this$props2 = this.props).makeStyles) === null || _this$props$makeStyle2 === void 0 ? void 0 : _this$props$makeStyle2.call(_this$props2);
  }
  renderMenu(items) {
    return (0, _jsxRuntime.jsx)(_Menu.Menu, {
      trigger: (0, _jsxRuntime.jsx)(AppNav.Item, {
        renderLabel: (0, _callRenderProp.callRenderProp)(this.props.renderTruncateLabel)
      }),
      children: items.map((item, index) => {
        return (0, _jsxRuntime.jsx)(_Menu.Menu.Item, {
          href: item.props.href ? item.props.href : void 0,
          onClick: item.props.onClick && !item.props.href ? item.props.onClick : void 0,
          children: (0, _callRenderProp.callRenderProp)(item.props.renderLabel)
        }, index);
      })
    });
  }
  render() {
    const _this$props3 = this.props,
      visibleItemsCount = _this$props3.visibleItemsCount,
      screenReaderLabel = _this$props3.screenReaderLabel,
      margin = _this$props3.margin,
      debounce = _this$props3.debounce,
      styles = _this$props3.styles;
    const passthroughProps = _View.View.omitViewProps((0, _omitProps.omitProps)(this.props, AppNav.allowedProps), AppNav);
    const renderBeforeItems = (0, _callRenderProp.callRenderProp)(this.props.renderBeforeItems);
    const renderAfterItems = (0, _callRenderProp.callRenderProp)(this.props.renderAfterItems);
    const hasRenderedContent = renderBeforeItems || renderAfterItems;
    return (0, _jsxRuntime.jsxs)(_View.View, {
      ...passthroughProps,
      as: "nav",
      css: [styles === null || styles === void 0 ? void 0 : styles.appNav, hasRenderedContent ? styles === null || styles === void 0 ? void 0 : styles.alignCenter : ''],
      margin: margin,
      display: hasRenderedContent ? 'flex' : 'block',
      elementRef: this.handleRef,
      children: [renderBeforeItems && (0, _jsxRuntime.jsx)("span", {
        children: renderBeforeItems
      }), (0, _jsxRuntime.jsx)(_TruncateList.TruncateList, {
        visibleItemsCount: visibleItemsCount,
        debounce: debounce,
        onUpdate: this.props.onUpdate,
        renderHiddenItemMenu: hiddenChildren => this.renderMenu(hiddenChildren),
        itemSpacing: styles === null || styles === void 0 ? void 0 : styles.horizontalMargin,
        fixMenuTriggerWidth: styles === null || styles === void 0 ? void 0 : styles.menuTriggerWidth,
        css: styles === null || styles === void 0 ? void 0 : styles.list,
        "aria-label": (0, _callRenderProp.callRenderProp)(screenReaderLabel),
        children: this.props.children
      }), renderAfterItems && (0, _jsxRuntime.jsx)("span", {
        children: renderAfterItems
      })]
    });
  }
}, _AppNav.displayName = "AppNav", _AppNav.componentId = 'AppNav', _AppNav.allowedProps = _props.allowedProps, _AppNav.propTypes = _props.propTypes, _AppNav.defaultProps = {
  children: null,
  debounce: 300,
  margin: '0',
  renderTruncateLabel: () => 'More',
  visibleItemsCount: 0
}, _AppNav.Item = _Item.Item, _AppNav)) || _class) || _class);
var _default = exports.default = AppNav;