import { Component } from 'react';
import type { AppNavItemProps } from './props';
/**
---
parent: AppNav
id: AppNav.Item
---
@module Item
**/
declare class Item extends Component<AppNavItemProps> {
    static readonly componentId = "AppNav.Item";
    static allowedProps: readonly (keyof {
        renderLabel: import("@instructure/shared-types").Renderable;
        renderAfter?: import("@instructure/shared-types").Renderable;
        renderIcon?: import("@instructure/shared-types").Renderable;
        href?: string;
        onClick?: (event: React.MouseEvent) => void;
        isSelected?: boolean;
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        isDisabled?: boolean;
    })[];
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        renderLabel: import("@instructure/shared-types").Renderable;
        renderAfter?: import("@instructure/shared-types").Renderable;
        renderIcon?: import("@instructure/shared-types").Renderable;
        href?: string;
        onClick?: (event: React.MouseEvent) => void;
        isSelected?: boolean;
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        isDisabled?: boolean;
    }>;
    static defaultProps: {
        readonly children: null;
        readonly isSelected: false;
        readonly cursor: "pointer";
        readonly isDisabled: false;
    };
    ref: Element | null;
    componentDidMount(): void;
    componentDidUpdate(): void;
    handleRef: (el: Element | null) => void;
    handleClick: (e: React.MouseEvent) => void;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default Item;
export { Item };
//# sourceMappingURL=index.d.ts.map