import { ComponentElement, Component } from 'react';
import { Item } from './Item';
import type { AppNavProps } from './props';
import { AppNavItemProps } from './Item/props';
/**
---
category: components
---
**/
declare class AppNav extends Component<AppNavProps> {
    static readonly componentId = "AppNav";
    static allowedProps: readonly (keyof {
        screenReaderLabel: string;
        debounce?: number;
        renderBeforeItems?: import("@instructure/shared-types").Renderable;
        renderAfterItems?: import("@instructure/shared-types").Renderable;
        margin?: import("@instructure/emotion").Spacing;
        elementRef?: (element: Element | null) => void;
        renderTruncateLabel?: import("@instructure/shared-types").Renderable;
        onUpdate?: (visibleItemsCount: {
            visibleItemsCount: number;
        }) => void;
        visibleItemsCount?: number;
        children?: React.ReactNode;
    })[];
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        screenReaderLabel: string;
        debounce?: number;
        renderBeforeItems?: import("@instructure/shared-types").Renderable;
        renderAfterItems?: import("@instructure/shared-types").Renderable;
        margin?: import("@instructure/emotion").Spacing;
        elementRef?: (element: Element | null) => void;
        renderTruncateLabel?: import("@instructure/shared-types").Renderable;
        onUpdate?: (visibleItemsCount: {
            visibleItemsCount: number;
        }) => void;
        visibleItemsCount?: number;
        children?: React.ReactNode;
    }>;
    static defaultProps: {
        children: null;
        debounce: number;
        margin: string;
        renderTruncateLabel: () => string;
        visibleItemsCount: number;
    };
    static Item: typeof Item;
    state: {
        isMeasuring: boolean;
    };
    ref: Element | null;
    componentDidMount(): void;
    componentDidUpdate(): void;
    handleRef: (el: Element | null) => void;
    renderMenu(items: ComponentElement<AppNavItemProps, Item>[]): import("@emotion/react/jsx-runtime").JSX.Element;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export { AppNav };
export default AppNav;
//# sourceMappingURL=index.d.ts.map